searchData={"items":[{"type":"module","title":"LiveExWebRTC.CoreComponents","doc":"Provides core UI components.\n\nAt first glance, this module may seem daunting, but its goal is to provide\ncore building blocks for your application, such as modals, tables, and\nforms. The components consist mostly of markup and are well-documented\nwith doc strings and declarative assigns. You may customize and style\nthem in any way you want, based on your application growth and needs.\n\nThe default components use Tailwind CSS, a utility-first CSS framework.\nSee the [Tailwind CSS documentation](https://tailwindcss.com) to learn\nhow to customize them or feel free to swap in another framework altogether.\n\nIcons are provided by [heroicons](https://heroicons.com). See `icon/1` for usage.","ref":"LiveExWebRTC.CoreComponents.html"},{"type":"function","title":"LiveExWebRTC.CoreComponents.back/1","doc":"Renders a back navigation link.","ref":"LiveExWebRTC.CoreComponents.html#back/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.back/1","doc":"<.back navigate={~p\"/posts\"}>Back to posts</.back>","ref":"LiveExWebRTC.CoreComponents.html#back/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.back/1","doc":"* `navigate` (`:any`) (required)","ref":"LiveExWebRTC.CoreComponents.html#back/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.back/1","doc":"* `inner_block` (required)","ref":"LiveExWebRTC.CoreComponents.html#back/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.button/1","doc":"Renders a button.","ref":"LiveExWebRTC.CoreComponents.html#button/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.button/1","doc":"<.button>Send!</.button>\n    <.button phx-click=\"go\" class=\"ml-2\">Send!</.button>","ref":"LiveExWebRTC.CoreComponents.html#button/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.button/1","doc":"* `type` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"LiveExWebRTC.CoreComponents.html#button/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.button/1","doc":"* `inner_block` (required)","ref":"LiveExWebRTC.CoreComponents.html#button/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.error/1","doc":"Generates a generic error message.","ref":"LiveExWebRTC.CoreComponents.html#error/1"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.error/1","doc":"* `inner_block` (required)","ref":"LiveExWebRTC.CoreComponents.html#error/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.flash/1","doc":"Renders flash notices.","ref":"LiveExWebRTC.CoreComponents.html#flash/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.flash/1","doc":"<.flash kind={:info} flash={@flash} />\n    <.flash kind={:info} phx-mounted={show(\"#flash\")}>Welcome Back!</.flash>","ref":"LiveExWebRTC.CoreComponents.html#flash/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.flash/1","doc":"* `id` (`:string`) - the optional id of flash container.\n* `flash` (`:map`) - the map of flash messages to display. Defaults to `%{}`.\n* `title` (`:string`) - Defaults to `nil`.\n* `kind` (`:atom`) - used for styling and flash lookup.Must be one of `:info`, or `:error`.\n* Global attributes are accepted. the arbitrary HTML attributes to add to the flash container.","ref":"LiveExWebRTC.CoreComponents.html#flash/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.flash/1","doc":"* `inner_block` - the optional inner block that renders the flash message.","ref":"LiveExWebRTC.CoreComponents.html#flash/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.flash_group/1","doc":"Shows the flash group with standard titles and content.","ref":"LiveExWebRTC.CoreComponents.html#flash_group/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.flash_group/1","doc":"<.flash_group flash={@flash} />","ref":"LiveExWebRTC.CoreComponents.html#flash_group/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.flash_group/1","doc":"* `flash` (`:map`) (required) - the map of flash messages.\n* `id` (`:string`) - the optional id of flash container. Defaults to `\"flash-group\"`.","ref":"LiveExWebRTC.CoreComponents.html#flash_group/1-attributes"},{"type":"function","title":"LiveExWebRTC.CoreComponents.header/1","doc":"Renders a header with title.","ref":"LiveExWebRTC.CoreComponents.html#header/1"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.header/1","doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"LiveExWebRTC.CoreComponents.html#header/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.header/1","doc":"* `inner_block` (required)\n* `subtitle`\n* `actions`","ref":"LiveExWebRTC.CoreComponents.html#header/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.hide/2","doc":"","ref":"LiveExWebRTC.CoreComponents.html#hide/2"},{"type":"function","title":"LiveExWebRTC.CoreComponents.hide_modal/2","doc":"","ref":"LiveExWebRTC.CoreComponents.html#hide_modal/2"},{"type":"function","title":"LiveExWebRTC.CoreComponents.icon/1","doc":"Renders a [Heroicon](https://heroicons.com).\n\nHeroicons come in three styles – outline, solid, and mini.\nBy default, the outline style is used, but solid and mini may\nbe applied by using the `-solid` and `-mini` suffix.\n\nYou can customize the size and colors of the icons by setting\nwidth, height, and background color classes.\n\nIcons are extracted from your `assets/vendor/heroicons` directory and bundled\nwithin your compiled app.css by the plugin in your `assets/tailwind.config.js`.","ref":"LiveExWebRTC.CoreComponents.html#icon/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.icon/1","doc":"<.icon name=\"hero-x-mark-solid\" />\n    <.icon name=\"hero-arrow-path\" class=\"ml-1 w-3 h-3 animate-spin\" />","ref":"LiveExWebRTC.CoreComponents.html#icon/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.icon/1","doc":"* `name` (`:string`) (required)\n* `class` (`:string`) - Defaults to `nil`.","ref":"LiveExWebRTC.CoreComponents.html#icon/1-attributes"},{"type":"function","title":"LiveExWebRTC.CoreComponents.input/1","doc":"Renders an input with label and error messages.\n\nA `Phoenix.HTML.FormField` may be passed as argument,\nwhich is used to retrieve the input name, id, and values.\nOtherwise all attributes may be passed explicitly.","ref":"LiveExWebRTC.CoreComponents.html#input/1"},{"type":"function","title":"Types - LiveExWebRTC.CoreComponents.input/1","doc":"This function accepts all HTML input types, considering that:\n\n  * You may also set `type=\"select\"` to render a ` ` tag\n\n  * `type=\"checkbox\"` is used exclusively to render boolean values\n\n  * For live file uploads, see `Phoenix.Component.live_file_input/1`\n\nSee https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input\nfor more information.","ref":"LiveExWebRTC.CoreComponents.html#input/1-types"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.input/1","doc":"<.input field={@form[:email]} type=\"email\" />\n    <.input name=\"my-input\" errors={[\"oh no!\"]} />","ref":"LiveExWebRTC.CoreComponents.html#input/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"LiveExWebRTC.CoreComponents.html#input/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.input/1","doc":"* `inner_block`","ref":"LiveExWebRTC.CoreComponents.html#input/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.label/1","doc":"Renders a label.","ref":"LiveExWebRTC.CoreComponents.html#label/1"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.label/1","doc":"* `for` (`:string`) - Defaults to `nil`.","ref":"LiveExWebRTC.CoreComponents.html#label/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.label/1","doc":"* `inner_block` (required)","ref":"LiveExWebRTC.CoreComponents.html#label/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.list/1","doc":"Renders a data list.","ref":"LiveExWebRTC.CoreComponents.html#list/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.list/1","doc":"<.list>\n      <:item title=\"Title\"><%= @post.title %></:item>\n      <:item title=\"Views\"><%= @post.views %></:item>\n    </.list>","ref":"LiveExWebRTC.CoreComponents.html#list/1-examples"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.list/1","doc":"* `item` (required) - Accepts attributes:\n\n  * `title` (`:string`) (required)","ref":"LiveExWebRTC.CoreComponents.html#list/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.modal/1","doc":"Renders a modal.","ref":"LiveExWebRTC.CoreComponents.html#modal/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.modal/1","doc":"<.modal id=\"confirm-modal\">\n      This is a modal.\n    </.modal>\n\nJS commands may be passed to the `:on_cancel` to configure\nthe closing/cancel event, for example:\n\n    <.modal id=\"confirm\" on_cancel={JS.navigate(~p\"/posts\")}>\n      This is another modal.\n    </.modal>","ref":"LiveExWebRTC.CoreComponents.html#modal/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.modal/1","doc":"* `id` (`:string`) (required)\n* `show` (`:boolean`) - Defaults to `false`.\n* `on_cancel` (`Phoenix.LiveView.JS`) - Defaults to `%Phoenix.LiveView.JS{ops: []}`.","ref":"LiveExWebRTC.CoreComponents.html#modal/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.modal/1","doc":"* `inner_block` (required)","ref":"LiveExWebRTC.CoreComponents.html#modal/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.show/2","doc":"","ref":"LiveExWebRTC.CoreComponents.html#show/2"},{"type":"function","title":"LiveExWebRTC.CoreComponents.show_modal/2","doc":"","ref":"LiveExWebRTC.CoreComponents.html#show_modal/2"},{"type":"function","title":"LiveExWebRTC.CoreComponents.simple_form/1","doc":"Renders a simple form.","ref":"LiveExWebRTC.CoreComponents.html#simple_form/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.simple_form/1","doc":"<.simple_form for={@form} phx-change=\"validate\" phx-submit=\"save\">\n      <.input field={@form[:email]} label=\"Email\"/>\n      <.input field={@form[:username]} label=\"Username\" />\n      <:actions>\n        <.button>Save</.button>\n      </:actions>\n    </.simple_form>","ref":"LiveExWebRTC.CoreComponents.html#simple_form/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.simple_form/1","doc":"* `for` (`:any`) (required) - the datastructure for the form.\n* `as` (`:any`) - the server side parameter to collect all input under. Defaults to `nil`.\n* Global attributes are accepted. the arbitrary HTML attributes to apply to the form tag. Supports all globals plus: `[\"autocomplete\", \"name\", \"rel\", \"action\", \"enctype\", \"method\", \"novalidate\", \"target\", \"multipart\"]`.","ref":"LiveExWebRTC.CoreComponents.html#simple_form/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.simple_form/1","doc":"* `inner_block` (required)\n* `actions` - the slot for form actions, such as a submit button.","ref":"LiveExWebRTC.CoreComponents.html#simple_form/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.table/1","doc":"Renders a table with generic styling.","ref":"LiveExWebRTC.CoreComponents.html#table/1"},{"type":"function","title":"Examples - LiveExWebRTC.CoreComponents.table/1","doc":"<.table id=\"users\" rows={@users}>\n      <:col :let={user} label=\"id\"><%= user.id %></:col>\n      <:col :let={user} label=\"username\"><%= user.username %></:col>\n    </.table>","ref":"LiveExWebRTC.CoreComponents.html#table/1-examples"},{"type":"function","title":"Attributes - LiveExWebRTC.CoreComponents.table/1","doc":"* `id` (`:string`) (required)\n* `rows` (`:list`) (required)\n* `row_id` (`:any`) - the function for generating the row id. Defaults to `nil`.\n* `row_click` (`:any`) - the function for handling phx-click on each row. Defaults to `nil`.\n* `row_item` (`:any`) - the function for mapping each row before calling the :col and :action slots. Defaults to `&Function.identity/1`.","ref":"LiveExWebRTC.CoreComponents.html#table/1-attributes"},{"type":"function","title":"Slots - LiveExWebRTC.CoreComponents.table/1","doc":"* `col` (required) - Accepts attributes:\n\n  * `label` (`:string`)\n* `action` - the slot for showing user actions in the last table column.","ref":"LiveExWebRTC.CoreComponents.html#table/1-slots"},{"type":"function","title":"LiveExWebRTC.CoreComponents.translate_error/1","doc":"Translates an error message using gettext.","ref":"LiveExWebRTC.CoreComponents.html#translate_error/1"},{"type":"function","title":"LiveExWebRTC.CoreComponents.translate_errors/2","doc":"Translates the errors for a field from a keyword list of errors.","ref":"LiveExWebRTC.CoreComponents.html#translate_errors/2"},{"type":"module","title":"LiveExWebRTC.Player","doc":"Component for sending and playing audio and video via WebRTC from a Phoenix app to a browser (browser subscribes).\n\nIt:\n* renders a single HTMLVideoElement\n* creates WebRTC PeerConnection both on the server and client side\n* connects those two peer connections negotiating a single audio and a single video track\n* attaches audio and video on the client side to the HTMLVideoElement\n* subscribes to the configured PubSub where it expects audio and video packets and sends them to the client side.\n\nWhen `LiveExWebRTC.Publisher` is used, audio an video packets are delivered automatically,\nassuming both components are configured with the same PubSub.\n\nIf `LiveExWebRTC.Publisher` is not used, you need to send track information and packets,\nand receive keyframe requests manually using specific PubSub topics.\nSee `LiveExWebRTC.Publisher` module doc for more.","ref":"LiveExWebRTC.Player.html"},{"type":"module","title":"JavaScript Hook - LiveExWebRTC.Player","doc":"Player live view requires JavaScript hook to be registered under `Player` name.\nThe hook can be created using `createPlayerHook` function.\nFor example:\n\n```javascript\nimport { createPlayerHook } from \"live_ex_webrtc\";\nlet Hooks = {};\nconst iceServers = [{ urls: \"stun:stun.l.google.com:19302\" }];\nHooks.Player = createPlayerHook(iceServers);\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  // ...\n  hooks: Hooks\n});\n```","ref":"LiveExWebRTC.Player.html#module-javascript-hook"},{"type":"module","title":"Simulcast - LiveExWebRTC.Player","doc":"Simulcast requires video codecs to be H264 (packetization mode 1) and/or VP8.\nSee `LiveExWebRTC.Publisher` module doc for more.","ref":"LiveExWebRTC.Player.html#module-simulcast"},{"type":"module","title":"Examples - LiveExWebRTC.Player","doc":"```elixir\ndefmodule LiveTwitchWeb.StreamViewerLive do\n  use LiveTwitchWeb, :live_view\n\n  alias LiveExWebRTC.Player\n\n  @impl true\n  def render(assigns) do\n  ~H\"\"\"\n   \n  \"\"\"\n  end\n\n  @impl true\n  def mount(_params, _session, socket) do\n    socket = Player.attach(socket, id: \"player\", publisher_id: \"publisher\", pubsub: LiveTwitch.PubSub)\n    {:ok, socket}\n  end\nend\n```","ref":"LiveExWebRTC.Player.html#module-examples"},{"type":"function","title":"LiveExWebRTC.Player.attach/2","doc":"Attaches required hooks and creates `t:t/0` struct.\n\nCreated struct is saved in socket's assigns and has to be passed to `LiveExWebRTC.Player.live_render/1`.\n\nOptions:\n* `id` [**required**] - player id. This is typically your user id (if there is users database).\nIt is used to identify live view and generated HTML video player.\n* `publisher_id` [**required**] - publisher id that this player is going to subscribe to.\n* `pubsub` [**required**] - a pubsub that player live view will use for receiving audio and video packets. See module doc for more info.\n* `on_connected` - callback called when the underlying peer connection changes its state to the `:connected`. See `t:on_connected/0`.\n* `on_packet` - callback called for each audio and video RTP packet. Can be used to modify the packet before sending via WebRTC to the other side. See `t:on_packet/0`.\n* `ice_servers` - a list of `t:ExWebRTC.PeerConnection.Configuration.ice_server/0`,\n* `ice_ip_filter` - `t:ExICE.ICEAgent.ip_filter/0`,\n* `ice_port_range` - `t:Enumerable.t(non_neg_integer())/1`,\n* `audio_codecs` - a list of `t:ExWebRTC.RTPCodecParameters.t/0`,\n* `video_codecs` - a list of `t:ExWebRTC.RTPCodecParameters.t/0`,\n* `pc_genserver_opts` - `t:GenServer.options/0` for the underlying `ExWebRTC.PeerConnection` process.\n* `class` - a list of CSS/Tailwind classes that will be applied to the HTMLVideoPlayer. Defaults to \"\".","ref":"LiveExWebRTC.Player.html#attach/2"},{"type":"function","title":"LiveExWebRTC.Player.live_render/1","doc":"Helper function for rendering Player live view.","ref":"LiveExWebRTC.Player.html#live_render/1"},{"type":"function","title":"Attributes - LiveExWebRTC.Player.live_render/1","doc":"* `socket` (`Phoenix.LiveView.Socket`) (required) - Parent live view socket.\n* `player` (`LiveExWebRTC.Player`) (required) - Player struct. It is used to pass player id and publisher id to the newly created live view via live view session.\n  This data is then used to do a handshake between parent live view and child live view during which child live view receives\n  the whole Player struct.\n\n* `class` (`:string`) - CSS/Tailwind classes for styling container. Defaults to `nil`.\n* `video_class` (`:string`) - CSS/Tailwind classes for styling HTMLVideoElement. Defaults to `nil`.","ref":"LiveExWebRTC.Player.html#live_render/1-attributes"},{"type":"type","title":"LiveExWebRTC.Player.on_connected/0","doc":"","ref":"LiveExWebRTC.Player.html#t:on_connected/0"},{"type":"type","title":"LiveExWebRTC.Player.on_packet/0","doc":"","ref":"LiveExWebRTC.Player.html#t:on_packet/0"},{"type":"type","title":"LiveExWebRTC.Player.t/0","doc":"","ref":"LiveExWebRTC.Player.html#t:t/0"},{"type":"module","title":"LiveExWebRTC.Publisher","doc":"Component for sending audio and video via WebRTC from a browser to a Phoenix app (browser publishes).\n\nIt:\n* renders:\n  * audio and video device selects\n  * audio and video stream configs\n  * stream recording toggle (with recordings enabled)\n  * stream preview\n  * transmission stats\n* on clicking \"Start Streaming\", creates WebRTC PeerConnection both on the client and server side\n* connects those two peer connections negotiatiing a single audio and video track\n* sends audio and video from selected devices to the live view process\n* publishes received audio and video packets to the configured PubSub\n* can optionally use the [ExWebRTC Recorder](https://github.com/elixir-webrtc/ex_webrtc_recorder) to record the stream\n\nWhen `LiveExWebRTC.Player` is used, audio and video packets are delivered automatically,\nassuming both components are configured with the same PubSub.\n\nIf `LiveExWebRTC.Player` is not used, you should use following topics and messages:\n* `streams:audio:#{publisher_id}:#{audio_track_id}` - for receiving audio packets\n* `streams:video:#{publisher_id}:#{video_track_id}:#{layer}` - for receiving video packets.\nThe message is in form of `{:live_ex_webrtc, :video, \"l\" | \"m\" | \"h\", ExRTP.Packet.t()}` or\n`{:live_ex_webrtc, :audio, ExRTP.Packet.t()}`. Packets for non-simulcast video tracks are always\nsent with \"h\" identifier.\n* `streams:info:#{publisher.id}\"` - for receiving information about publisher tracks and their layers.\nThe message is in form of: `{:live_ex_webrtc, :info | :bye, audio_track :: ExWebRTC.MediaStreamTrack.t(), video_track :: ExWebRTC.MediaStreamTrack.t()}`.\n* `publishers:#{publisher_id}` for sending keyframe request.\nThe message must be in form of `{:live_ex_webrtc, :keyframe_req, \"l\" | \"m\" | \"h\"}`\nE.g.\n```elixir\nPubSub.broadcast(LiveTwitch.PubSub, \"publishers:my_publisher\", {:live_ex_webrtc, :keyframe_req, \"h\"})\n```","ref":"LiveExWebRTC.Publisher.html"},{"type":"module","title":"JavaScript Hook - LiveExWebRTC.Publisher","doc":"Publisher live view requires JavaScript hook to be registered under `Publisher` name.\nThe hook can be created using `createPublisherHook` function.\nFor example:\n\n```javascript\nimport { createPublisherHook } from \"live_ex_webrtc\";\nlet Hooks = {};\nconst iceServers = [{ urls: \"stun:stun.l.google.com:19302\" }];\nHooks.Publisher = createPublisherHook(iceServers);\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  // ...\n  hooks: Hooks\n});\n```","ref":"LiveExWebRTC.Publisher.html#module-javascript-hook"},{"type":"module","title":"Simulcast - LiveExWebRTC.Publisher","doc":"Simulcast requires video codecs to be H264 (packetization mode 1) and/or VP8. E.g.\n\n```elixir\nvideo_codecs = [\n  %RTPCodecParameters{\n    payload_type: 98,\n    mime_type: \"video/H264\",\n    clock_rate: 90_000,\n    sdp_fmtp_line: %FMTP{\n      pt: 98,\n      level_asymmetry_allowed: true,\n      packetization_mode: 1,\n      profile_level_id: 0x42E01F\n    }\n  },\n  %RTPCodecParameters{\n    payload_type: 96,\n    mime_type: \"video/VP8\",\n    clock_rate: 90_000\n  }\n]\n```\n\nYou can also use the shorthands for default H264 and VP8 codec parameters:\n```elixir\nvideo_codecs = [:h264, :vp8]\n```","ref":"LiveExWebRTC.Publisher.html#module-simulcast"},{"type":"module","title":"Examples - LiveExWebRTC.Publisher","doc":"```elixir\ndefmodule LiveTwitchWeb.StreamerLive do\n  use LiveTwitchWeb, :live_view\n\n  alias LiveExWebRTC.Publisher\n\n  @impl true\n  def render(assigns) do\n  ~H\"\"\"\n   \n  \"\"\"\n  end\n\n  @impl true\n  def mount(_params, _session, socket) do\n    socket = Publisher.attach(socket, id: \"publisher\", pubsub: LiveTwitch.PubSub)\n    {:ok, socket}\n  end\nend\n```","ref":"LiveExWebRTC.Publisher.html#module-examples"},{"type":"function","title":"LiveExWebRTC.Publisher.attach/2","doc":"Attaches required hooks and creates `t:t/0` struct.\n\nCreated struct is saved in socket's assigns and has to be passed to `LiveExWebRTC.Publisher.live_render/1`.\n\nOptions:\n* `id` [**required**] - publisher id. This is typically your user id (if there is users database).\nIt is used to identify live view and generated HTML elements.\n* `pubsub` [**required**]  - a pubsub that publisher live view will use for broadcasting audio and video packets received from a browser. See module doc for more info.\n* `recordings?` - whether to allow for recordings or not. Defaults to true.\n  See module doc and `t:on_disconnected/0` for more info.\n* `recorder_opts` - a list of options that will be passed to the recorder. In particular, they can contain S3 config where recordings will be uploaded. See `t:ExWebRTC.Recorder.option/0` for more.\n* `on_connected` - callback called when the underlying peer connection changes its state to the `:connected`. See `t:on_connected/0`.\n* `on_disconnected` - callback called when the underlying peer connection process terminates. See `t:on_disconnected/0`.\n* `on_recording_finished` - callback called when the stream recording has finised. See `t:on_recording_finished/0`.\n* `on_packet` - callback called for each audio and video RTP packet. Can be used to modify the packet before publishing it on a pubsub. See `t:on_packet/0`.\n* `ice_servers` - a list of `t:ExWebRTC.PeerConnection.Configuration.ice_server/0`,\n* `ice_ip_filter` - `t:ExICE.ICEAgent.ip_filter/0`,\n* `ice_port_range` - `t:Enumerable.t(non_neg_integer())/1`,\n* `audio_codecs` - a list of `t:ExWebRTC.RTPCodecParameters.t/0`,\n* `video_codecs` - a list of `t:ExWebRTC.RTPCodecParameters.t/0`,\n* `pc_genserver_opts` - `t:GenServer.options/0` for the underlying `ExWebRTC.PeerConnection` process.","ref":"LiveExWebRTC.Publisher.html#attach/2"},{"type":"function","title":"LiveExWebRTC.Publisher.live_render/1","doc":"Helper function for rendering Publisher live view.","ref":"LiveExWebRTC.Publisher.html#live_render/1"},{"type":"function","title":"Attributes - LiveExWebRTC.Publisher.live_render/1","doc":"* `socket` (`Phoenix.LiveView.Socket`) (required) - Parent live view socket.\n* `publisher` (`LiveExWebRTC.Publisher`) (required) - Publisher struct. It is used to pass publisher id to the newly created live view via live view session.\n  This data is then used to do a handshake between parent live view and child live view during which child live\n  view receives the whole Publisher struct.","ref":"LiveExWebRTC.Publisher.html#live_render/1-attributes"},{"type":"type","title":"LiveExWebRTC.Publisher.on_connected/0","doc":"Called when WebRTC has connected.","ref":"LiveExWebRTC.Publisher.html#t:on_connected/0"},{"type":"type","title":"LiveExWebRTC.Publisher.on_disconnected/0","doc":"Called when WebRTC has disconnected.","ref":"LiveExWebRTC.Publisher.html#t:on_disconnected/0"},{"type":"type","title":"LiveExWebRTC.Publisher.on_packet/0","doc":"","ref":"LiveExWebRTC.Publisher.html#t:on_packet/0"},{"type":"type","title":"LiveExWebRTC.Publisher.on_recorder_message/0","doc":"Called when recorder sends a message to the Publisher.\n\nFor exact meaning of the second argument, refer to `t:ExWebRTC.Recorder.message/0`.","ref":"LiveExWebRTC.Publisher.html#t:on_recorder_message/0"},{"type":"type","title":"LiveExWebRTC.Publisher.on_recording_finished/0","doc":"Called when recorder finishes stream recording.\n\nFor exact meaning of the second argument, refer to `t:ExWebRTC.Recorder.end_tracks_ok_result/0`.","ref":"LiveExWebRTC.Publisher.html#t:on_recording_finished/0"},{"type":"type","title":"LiveExWebRTC.Publisher.t/0","doc":"","ref":"LiveExWebRTC.Publisher.html#t:t/0"},{"type":"extras","title":"LiveExWebRTC","doc":"# LiveExWebRTC\n\n[![Hex.pm](https://img.shields.io/hexpm/v/live_ex_webrtc.svg)](https://hex.pm/packages/live_ex_webrtc)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/live_ex_webrtc)\n\nPhoenix Live Components for [Elixir WebRTC](https://github.com/elixir-webrtc/ex_webrtc).","ref":"readme.html"},{"type":"extras","title":"Installation - LiveExWebRTC","doc":"In your `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:live_ex_webrtc, \"~> 0.8.0\"}\n  ]\nend\n```\n\nIn your `tailwind.config.js`\n\n```js\nmodule.exports = {\n  content: [\n    \"../deps/live_ex_webrtc/**/*.*ex\" // ADD THIS LINE\n  ]\n}\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - LiveExWebRTC","doc":"`LiveExWebRTC` comes with two `Phoenix.LiveView`s:\n* `LiveExWebRTC.Publisher` - sends audio and video via WebRTC from a web browser to a Phoenix app (browser publishes)\n* `LiveExWebRTC.Player` - sends audio and video via WebRTC from a Phoenix app to a web browser and plays it in the HTMLVideoElement (browser subscribes)\n\nSee module docs and [live_broadcaster](https://github.com/elixir-webrtc/live_broadcaster) for more.","ref":"readme.html#usage"},{"type":"extras","title":"Local development - LiveExWebRTC","doc":"For local development:\n* include `live_ex_webrtc` in your `mix.exs` via `path` \n* modify `NODE_PATH` env variable in your esbuild configuration, which is located in `config.exs` - this will allow for importing javascript hooks from `live_ex_webrtc`.\n\n  For example:\n\n  ```elixir\n  config :esbuild,\n    # ...\n    default: [\n      # ...\n      env: %{\n        \"NODE_PATH\" => \"#{Path.expand(\"../deps\", __DIR__)}:/path/to/parent/dir/of/live_ex_webrtc\"\n      }\n    ]\n  ```\n\n* modify `content` in `tailwind.config.js` - this will compile tailwind classes used in live components.\n  \n  For example:\n\n  ```js\n  module.exports = {\n    content: [\n      // ...\n      \"../deps/**/*.ex\"\n    ]\n  }\n  ```\n\n> #### Important {: .info}\n> Separate paths with `:` on MacOS/Linux and with `;` on Windows.\n\n> #### Important {: .info}\n> Specify path to live_ex_webrtc's parent directory.","ref":"readme.html#local-development"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}